<!DOCTYPE html>
<html>
<head>
<title>Pump - {{ title_blurb }} - {{ version }}</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<style type="text/css">

/* Main data table */
.table {
    width: 500px;
    table-layout: fixed;
}
.table.history_graph_table {
    width: 700px;
}

.table_col1 {
    width: 290px;
}

.table_col2 {
    width: 100px;
}

/* Slim down for mobile devices */
@media (max-width: 800px) {
    .title, .table_title {
        margin-top: 5px;
        margin-bottom: 5px;
    }

    .table {
        width: 95%;
    }

    .table_col1 {
        width: 70%;
    }

    .table_col2 {
        width: 30%;
    }

}

.diff { }
.diff_value { font-size: small; word-wrap: break-word}
div.category { float: left; }
.cell_value { word-wrap: break-word;  } */
.cell_header { font-weight: bold; word-wrap: break-word; }
#varscsv_div { outline: 1px solid black; }
#varscsv_input { width: 100% }
#update_executable_div { outline: 1px solid red; }
#development { outline: 1px solid black; }
/* no idea what inline-block is, but it shows development button correctly below */
#data { width: 100%; display: inline-block}
#last_update_time { float: left; padding-left: 5px }

/* TODO: width is a function of the number of indicators, should be parametized */
#status_indicators_div { width: 100%; height: 20px; }
.status_indicator { width: 100px; height: 100%; font-size: small; float: left; text-align: center; }

#total_daily { width: 100%; float: right; }
#daily_flow_canvas { width: 100%; max-width: 1440px; height: 100px; cursor: none; }

.legend { pointer-events: none; }

#menu { width: 100%; margin-bottom: 5px }

/* menu "buttons" */
a.menu {
    background:#eee;
    text-decoration:none;
    color:#333;
    font-family:Arial, sans-serif;
    font-size:11px;
    font-weight:bold;
    padding:3px 5px;
    border:1px solid #aaa;
    border-radius:3px;
    cursor:default;
}

a.menu:hover {
    background-color:#f2f2f2;
    border-color:#888;
    box-shadow:0 0 2px #ccc;
}

a.menu:active {
    vertical-align:-1px;
}
</style>
</head>
<body>
<script>

// Server provided parameters

var rate = {{ rate }}; // update rate
var client_version = "{{ version }}"; // the server can change under us, this is >= server_version

var http_headers = {{ http_headers | tojson }}; // allows working behind basic authorization
var do_not_display = {{ do_not_display | tojson }};
var display_mapping = {{ display_mapping | tojson }};
var value_mapping = {{ value_mapping | tojson }};
var headers_whitelist = {{ headers_whitelist | tojson }};
var floating_point_digits_after_decimal_point = {{ floating_point_digits_after_decimal_point }};

var graph_width = {{ graph_width }};
var graph_height = {{ graph_height }};

var graph_enabled = {{ graph_enabled | tojson }};

var server_state = {{ server_state | tojson }};

var averages_data = {{ averages_data | tojson }};


function hostpost(path, body_key, body, params)
{
    var data = new FormData();
    data.append(body_key, body);
    return fetch(
        hosturl(path, params),
        {
            method: "POST",
            body: data,
            headers: http_headers,
        });
}


/* Long operation status reporting */

function long_operation__create(caption)
{
    var el = document.getElementById('long_operation_div');
    var long_operation_start = new Date();
    el.innerHTML = 'started ' + caption;
    return {
      update: function (html) {
          el.innerHTML = html;
      },
      finished: function () {
        let dt = long_operation_start - (new Date());
        console.log(dt.toFixed(2));
        el.innerHTML = '';
      }
    }
}


function hostpostfile(path, file, params)
{
    let ret = hostpost(path, "file", file, params);
    let lo = long_operation__create('upload to server');
    ret.finally(function () {
        lo.finished();
    });
    return ret;
}


function hostpostjson(path, payload, params)
{
    let ret = hostpost(path, "json", JSON.stringify(payload), params);
    let lo = long_operation__create('uploading to server');
    ret.finally(function () {
        lo.finished();
    });
    return ret;
}


// Host access (GET only with server supplied http_headers)
function hostget(path, params)
{
    let url = hosturl(path, params);
    return fetch(url, {headers: http_headers});
}


function hosturl(rel_path, params)
{
    // strip query parameters but add rel_path which can contain already encoded parameters
    let ret = window.location.origin + window.location.pathname;
    if (ret[ret.length - 1] !== '/') {
        ret += '/';
    }
    // remove double '/' - given by flask in it's url_for
    if (rel_path[0] == '/') {
        rel_path = rel_path.substring(1, rel_path.length);
    }
    let url = ret + rel_path;
    if (params !== undefined) {
        let first = true;
        for (let key in params) {
            url += (first ? "?" : "&") + key + "=" + encodeURIComponent(params[key]);
            first = false;
        }
    }
    return url;
}

// Utilities
function pad(n, width, z) {
    z = z || '0';
    n = n + '';
    return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
}

function input_int_to_url(el, path)
{
    el.onkeypress = function (ev) {
        if (ev.key !== 'Enter') {
            return;
        }
        var v = Number.parseInt(print_time_el.value);
        if (isNaN(v)) {
            console.debug('not an integer - add an error value');
        }

        // TODO: make it a PUT / POST
        hostget(path + v)
            .then(function (response) {
                console.log(url + ': restarted ' + response);
            });
    };
}

function toggle_display(id) {
    toggle_display_of_element(document.getElementById(id));
}

function toggle_display_of_element(el) {
    var new_val = el.style.display == 'none' ? '' : 'none';
    el.style.display = new_val;
}


function toggle_tab(tab_selector, tab_id)
{
    // if tab is already shown, hide it
    let all_elements = Array.from(document.querySelectorAll(tab_selector));
    let tab_is_hidden = document.getElementById(tab_id).style.display == 'none';
    let tab_new_state = tab_is_hidden ? '' : 'none'; // reverse it
    for (let i in all_elements) {
        let el = all_elements[i];
        el.style.display = el.id == tab_id ? tab_new_state : 'none';
    }
}

function toggle_menu_tab(shown_id)
{
    toggle_tab('div.menu_tab', shown_id);
}


</script>
<h1 class="title">Comet-ME Pump - {{ title_blurb }}</h1>
<div class="control">

<!-- Menu -->

<div id="menu">
<a href="#" class="menu" id="download_toggle" onclick="toggle_menu_tab('download_div')">Download Menu</a>

<a href="#" class="menu" id="varscsv_toggle" onclick="toggle_menu_tab('varscsv_div')">Pump Variables</a>

<a href="#" class="menu" id="update_executable_div_toggle" onclick="toggle_menu_tab('update_executable_div')">
Monitor update from Code-Composer</a>

<a href="#" class="menu" id="download_raw_toggle" onclick="toggle_menu_tab('download_raw_div')">Download Raw Files</a>
</div>

<!-- Raw files -->
<div class="menu_tab" id="download_raw_div" style="display: none">
</div>

<!-- Download -->

<div class="menu_tab" id="download_div" style="display: none">
<input type="date" id="download_date_start">
<input type="date" id="download_date_end">
<br>Averaging<br>
<input class="download_interval" type="radio" name="interval" value="1" checked>1 Second (almost raw)<br>
<input class="download_interval" type="radio" name="interval" value="60" checked>1 Minute<br>
<input class="download_interval" type="radio" name="interval" value="300">5 Minutes<br>
<input class="download_interval" type="radio" name="interval" value="900">15 Minutes<br>
<button id="download_button">Download</button>
</div>

<!-- Executable  & Vars.csv -->

<div class="menu_tab" id="varscsv_div" style="display: none; width: 100%">
<p>This file is parsed before it is saved, so you cannot save wrong files. However, you can probably discover bugs anyway. Be <span style="color: red">careful!</span></p>
<textarea cols="80" rows="30" id="varscsv_input" autocomplete="off"></textarea>
<button id="varscsv_button" onclick="varscsv_button_onclick()">Submit</button>
</div>

<div class="menu_tab" id="update_executable_div" style="display: none; width: 100%">
    <p>Please verify it is a <b>Release</b> build.
    File name is <b>{{ PUMPMON_ELF_basename }}</b> </p>
    <label for="executable_file_upload">Click and select to upload (no additional button!)</label>
    <input type="file" id="executable_file_upload" onchange="update_executable(this.files)">
</div>

<!-- Last update time -->

<div id="status_indicators_div">
{% for dev, state in server_state['devices'].items() %}
<div id="status_{{ dev }}_usb_div" class="status_indicator" style="background-color: {{ "rgba(0, 255, 0, 0.5)" if state else "rgba(255, 0, 0, 0.5)" }}">
USB {{ dev }} {{ "ok" if state else "off" }}
</div>
{% endfor %}
<div id="last_update_time"></div>
</div>

<div id="error_div"></div>

<div id="long_operation_div"></div>

</div>

<!-- Daily Flow -->

<div id="total_daily">Total Daily Flow: <span id="total_daily_flow_span">{{ averages_data['FlowDaily'] }}</span> liters<br>
<div style="width: 100%; height: 100px; position: relative">
    <canvas id="daily_flow_canvas" width="1440" height="100" style="position: absolute; top: 0px; left: 0px"></canvas>
    <div class="legend" id="flow_hover_div" style="position: absolute; top: 10px; left: 10px"></div>
    <div class="legend" id="power_hover_div" style="position: absolute; top: 35px; left: 10px"></div>
    <div class="legend" id="time_hover_div" style="position: absolute; top: 60px; left: 10px"></div>
</div>
</div>

<!-- Data tables -->

<div id="data">
{% for cat in categories %}

<div class="category">
<h2 class="table_title">{{ cat }}</h2>
<table id="{{ cat }}_table" class="table {{ "history_graph_table" if graph_enable else "" }}">
<colgroup>
  <col span="1" class="table_col1">
  <col span="1" style="width: 5px;">
  <col span="1" class="table_col2">
  {% if graph_enabled %}
  <col span="1" style="width: 200px;">
  {% endif %}
</colgroup>
<tr>
    <th class="cell_header"></th>
    <th></th>
    <th class="cell_header">Value</td>
    {% if graph_enabled %}
    <th class="cell_header diff"></th>
    {% endif %}
</tr>
{% for key, value in display_data[cat] %}
<tr>
    <th class="cell_header" id="cell_{{ key }}_title">{{ key }}</th>
    <td></td>
    <td class="cell_value" id="cell_{{ key }}">{{ value }}</td>
    {% if graph_enabled %}
    <td class="diff diff_cell" id="cell_{{ key }}_diff">
        <canvas id="graph_{{ key }}" width="{{ graph_width }}" height="{{ graph_height }}">
        <!-- no fallback content needed, just show nothing -->
        </canvas>
    </td>
    {% endif %}
</tr>
{% endfor %}
</table>
</div>

{% endfor %}
</div>

<!-- End Data tables -->

<!-- Start Development -->
<button id="development_toggle" onclick="toggle_display('development')">Development</button>

<div id="development" style="display: none; width: 100%">
<p>version {{ version }}</p>
<p>bugs: <span id="bugs_span"></span></p>
    <div>Initial timestamp {{ timestamp_str }} ({{ timestamp }})</div>
    <div>Last timestamp <span id="dev_last_timestamp"></span> milliseconds since epoch UTC, <span id="dev_last_timestamp_diff"></span> from client clock</div>
    <div>
        Print time in Milliseconds (default is 40, range is 20-1000). Cannot be larger than MPPT loop time.
        <input id="print_time"></input>
    </div>
    <div>
        MPPT loop time in Milliseconds (default is 1000)
        <input id="loop_time"></input>
    </div>
<button id="toggle_diff">last</button>
<div id="todo">
<pre>
Noam, 29th of June~

1.      Can you start the monitoring only when flgs.UV is =0 so we do not
have all night readings.

2.      There are different S/W version on the server and the pumpmon. I do
not know if it requires any changes.

3.      The status of the USB are always red on the server

4.      Can you set real time and not unix time on the raw data files too,
it will save a lot of work in the analysis of the data.
</pre>
</div>
</div>
<!-- End Development -->



<script>

var categories = {{ categories | tojson }};
var start_timestamp = {{ timestamp }};
var millis_since_last_update_of_timestamp = 0; // milliseconds
var last_timestamps_in_message = {'mppt': 0, 'pump': 0, 'flow': 0};
var last_new_network_message_timestamp = 0; // time when we got the last different timestamp message
var last_network_message_timestamp = 0; // time when we got the last message

/* History graphs */

var graph_initial = {

{% for cat in categories %}
{% for key, value in display_data[cat] %}
 "{{ key }}": "{{ value }}",
{% endfor %}
{% endfor %}
};

var graph_history;

var graph_limits;

var graph_dt = 1000; // milliseconds

const graph_fill_undefined = 2;


function graph_update(updated, value_str)
{
    if (!graph_enabled) {
        return;
    }
    let arr = graph_history[updated];
    if (arr === undefined) {
        return;
    }
    let value = parseFloat(value_str);
    if (isNaN(value)) {
        return;
    }
    // Fill back up to graph_fill_undefined undefinds - in affect glossing over an update rate up to fade_rate / (1 + graph_fill_undefined)
    // i.e. 0.5 Hz for graph_fill_undefined = 1 and graph_dt = 1000
    arr[0] = value;
    for (let i = graph_fill_undefined; i > 0 ; --i) {
        if (arr[i] == undefined && arr[i + 1] != undefined) {
            arr[i] = arr[i + 1];
        }
    }
    graph_limits_update(updated);
}

function graph_limits_update(key)
{
    let limit = graph_limits[key];
    // for now leave the bottom as zero
    // the top is changed to either twice up or twice down
    // hysteresis:
    //  up: if the current is below the max
    //  down: if the current is above the max * 1.1
    let cur = graph_history[key].filter(x => x !== undefined);
    let curmax = Math.max(...cur);
    let cur_limit = limit[1];
    if (cur_limit < 600 && curmax * 1.1 > cur_limit) {
        limit[1] = cur_limit * 2;
    }
    if (cur_limit > 2 && curmax * 2.6 < cur_limit) {
        limit[1] = cur_limit / 2;
    }
}


function graph_render_helper(key)
{
    let arr = graph_history[key];
    // We don't support some types, like categorical data, right now.
    if (arr === undefined) {
        return true;
    }
    let min_val = graph_limits[key][0];
    let max_val = graph_limits[key][1];
    let canvas = document.getElementById('graph_' + key);
    if (canvas === undefined) {
        console.error("missing canvas element for " + key);
        return false;
    }
    return render_graph(canvas, arr,
        {
            min_val: min_val, max_val: max_val,
            render_marker: true,
            width: graph_width, height: graph_height
        });
}


function render_graph__single(ctx, arr, color, d, size)
{
    if (color === undefined) {
        color = 'rgb(20, 20, 20)';
    }
    ctx.fillStyle = color;
    let width = size.width;
    let height = size.height;
    // use max_val as the minimum
    let max_val = d.max_val || Math.max.apply(undefined, arr.filter(x => !isNaN(x)));
    for (let i = 0 ; i < arr.length ; ++i) {
        let val = arr[i];
        if (val === undefined || val === null || isNaN(val)) {
            continue; // leave a gap
        }
        let x = parseInt(i * width / arr.length);
        let y = height - 1 - ((val - d.min_val) / (max_val - d.min_val) * (height - 1)); // 0 is top most
        ctx.fillRect(x, y, 1, 1);
    }
}


function render_graph(canvas, arr, d)
{
    if (d === undefined) {
        d = {}
    }
    if (!canvas.getContext) {
        console.error("browser doesn't support canvas drawing");
        return false;
    }
    d.width = canvas.width;
    d.height = canvas.height;
    let ctx = canvas.getContext('2d');

    // clear first
    ctx.fillStyle = 'rgb(255, 255, 255)';
    ctx.fillRect(0, 0, d.width, d.height);

    // render ticker
    if (arr !== undefined) {
        render_graph__single(ctx, arr, undefined, d, d);
    }
    if (d.data !== undefined) {
        for (let key in d.data) {
            let data = d.data[key];
            render_graph__single(ctx, data['data'], data['color'], data, d);
        }
    }

    if (d.render_marker) {
        // render a minimal up / down marker
        const marker_len = 5;
        ctx.fillStyle = 'rgba(200, 0, 0, 0.5)';
        ctx.fillRect(0, 0, 1, d.height - 1);
        ctx.fillRect(0, d.height - 1, marker_len, 1);
    }

    let vert_count = d.verticals === undefined ? 0 : d.verticals.length;
    for (let v_i = 0 ; v_i < vert_count; ++v_i) {
        let vert = d.verticals[v_i];
        let color = vert.color;
        let pos = parseInt(vert.position * canvas.width / 1440);
        ctx.fillStyle = color;
        ctx.fillRect(pos, 0, 1, d.height - 1);
    }

    return true;
}

var graph_render_error = false;

function graph_render() {
    for (let key in graph_history) {
        if (!graph_render_helper(key)) {
            graph_render_error = true;
        }
    }
}

function graph_history_fade() {
    if (graph_render_error) {
        // error rendering, quit rendering loop
        return;
    }
    // render all history, from scratch
    // TODO: consider using the existing timeout. Think about the update cycle. We want
    // the text update and the ticker update to happen at the same time, but
    // we also want the ticker to be up to date wrt passing time.
    // move all history one element to the right, freeing the last one
    for (let key in graph_history) {
        let arr = graph_history[key];
        for (let x = graph_width - 2 ; x >= 0; --x) {
            arr[x + 1] = arr[x];
        }
        // leave first value as undefined, so that we see lack of updates as gaps
        arr[0] = undefined;
        graph_limits_update(key);
    }
    requestAnimationFrame(graph_render);
}


/* time diff element */

var last_update_time_el = document.getElementById('last_update_time');
var dev_last_timestamp_el = document.getElementById('dev_last_timestamp');
var dev_last_timestamp_diff_el = document.getElementById('dev_last_timestamp_diff');

function time_difference_str(millis_since_epoch)
{
    let t = millis_since_epoch;
    return '' + t / 1000.0 + ' seconds';
}

// TODO - add a "X not logging" large warning
function update_last_update_time(times_in_milliseconds)
{
    let most_recent = undefined;
    let current = new Date();
    last_network_message_timestamp = current;

    for (let cat in times_in_milliseconds) {
        let cat_update = times_in_milliseconds[cat];
        if (isNaN(cat_update)) {
            continue;
        }
        if (most_recent === undefined) {
            most_recent = cat_update;
        } else {
            most_recent = Math.max(most_recent, cat_update);
        }
        let cat_last = last_timestamps_in_message[cat];
        if (cat_last < cat_update) {
            last_timestamps_in_message[cat] = cat_update;
            last_new_network_message_timestamp = current;
        }
    }

    update_last_update_time_text(current);
}


function local_now_timestamp()
{
    let d = new Date();
    let millis = d - 0;
    return millis;
}


function local_day_minute_from_timestamp(ts)
{
    let now = new Date();
    let start_of_day = new Date(1900 + now.getYear(), now.getMonth(), now.getDate(), 0, 0, 0, 0);
    let day_ts = start_of_day - 0;
    return parseInt((ts - day_ts) / 1000 / 60);
}


function update_last_update_time_text(current)
{
    let cutoff = 5000;
    let current_utc = (current - 0) + current.getTimezoneOffset() * 60000;
    dev_last_timestamp_el.textContent = JSON.stringify(last_timestamps_in_message);
    dev_last_timestamp_diff_el.textContent = (
        'mppt: ' + time_difference_str(current_utc - last_timestamps_in_message['mppt'])
        + ' ; controller: ' + time_difference_str(current_utc - last_timestamps_in_message['pump'])
        );
    let dt_update = current - last_new_network_message_timestamp;
    let dt_network = current - last_network_message_timestamp
    if (dt_network > cutoff) {
        let dt_str = (dt_network / 1000.0).toFixed(0);
        last_update_time_el.textContent = 'server not available - last seen ' + dt_str + ' seconds ago';
    } else {
        if (dt_update > cutoff) {
            let dt_str = (dt_update / 1000.0).toFixed(0);
            last_update_time_el.textContent = 'last updated ' + dt_str + ' seconds ago';
        } else {
            last_update_time_el.textContent = 'up to date';
        }
    }
}

var ticker_update_dt = 1000.0; // milliseconds
function ticker_update_callback() {
    let now = new Date();
    update_last_update_time_text(now);
    window.setTimeout(ticker_update_callback, ticker_update_dt);
}
ticker_update_callback(); // arm timer


update_last_update_time({mppt: {{ timestamp }}, pump: {{ timestamp }}, flow: {{ timestamp }} });

// second simplest refresh
function reload()
{
    console.debug('reload');
    window.location.reload();
}

function isfloat(value)
{
    return !isNaN(parseFloat(value));
}

function display_cleanup(value)
{
    // all floats with 2 places after the decimal place
    if (isfloat(value)) {
        var f = parseFloat(value);
        f = Math.max(0, f); // don't show negative values. For anything. Requirement is just for power, but simpler this way
        return f.toFixed(floating_point_digits_after_decimal_point);
    }
    return value;
}

var bugs = {};
function log_bug(name)
{
    if (bugs[name] !== undefined) {
        return;
    }
    bugs[name] = 1;
    let el = document.getElementById('bugs_span');
    el.textContent = JSON.stringify(bugs);
}

// Returns timestamp / RecordedTime
function update_table(js, cat)
{
    var time;
    var updated = {};
    let wl = headers_whitelist[cat];
    let dm = display_mapping[cat];
    let vm = value_mapping[cat]
    let dnd = do_not_display[cat];

    for (let prop in js) {
        let key = js[prop][0];
        let value = js[prop][1];
        let display = dm[key] === undefined ? key : dm[key];
        let valuemap = vm[key];

        // Special case RecordedTime & timestamp
        if (key === 'RecordedTime' || key === 'timestamp') {
            value = Number.parseFloat(value);
            time = value;
        }
        // ignore messages in the past
        if (time < last_timestamps_in_message[cat]) {
            log_bug('server old messages ' + cat);
            continue;
        }

        if (wl[key] === undefined || dnd[key]) {
            continue;
        }
        // ignore empty values - we show the last updated value (technically this means we should have a last updated field for each cell,
        // but we are relying on the fact all of the values should be updated close by, just a few milliseconds apart)
        if (value.length == 0) {
            continue;
        }

        // use value map if available to show value per map
        if (valuemap !== undefined) {
            if (valuemap.map !== undefined) {
                let new_value = valuemap.map[value];
                if (new_value !== undefined) {
                    value = new_value;
                }
            }
        }

        if (updated[display] === undefined) {
            updated[display] = [value];
        } else {
            updated[display].push(value);
        }
    }
    for (let display in updated) {
        let values = updated[display];
        let value = (
            (values.length == 1 || !isfloat(values[0]))
            ? values[0]
            : Math.max(...values.map(parseFloat)));
        var full_key = 'cell_' + display;
        let el = document.getElementById(full_key);
        if (el === null) {
            console.debug('error - server gave empty table, refreshing');
            reload();
        }

        let el_diff = document.getElementById(full_key + '_diff');
        let new_display = display_cleanup(value);
        graph_update(display, value);
        el.textContent = new_display;
    }
    return time;
}


function update_display(js)
{
    let data = js['data'];
    let meta = js['meta'];
    server_state = js['server_state'];
    let server_version = meta['version'];
    let server_version_str = server_version[0] + "." + server_version[1] + "." + server_version[2];
    if (server_version_str != client_version) {
        console.log('reloading for updated server version')
        reload();
    }
    var times = {}
    for (var i in categories) {
        var cat = categories[i];
        times[cat] = update_table(data[cat], cat);
    }
    update_averages(times['pump'], data['averages']);
    update_status_indicators(server_state);
    update_last_update_time(times);
}

var first_pull_time = new Date();
var update_count = 0;
var raw_files_update_frequency = 10;

function pull()
{
    update_count = update_count + 1;

    let start_time = new Date();

    if (start_time.getDay() != first_pull_time.getDay()) {
        console.log('reloading because of change of day');
        reload();
    }

    hostget("latest", {client_version: client_version})
        .then(function (response) {
            return response.json();
        }).then(function (js) {
            update_display(js);
        }).finally(function () {
            // TODO: add error condition and give feedback that there is no network connection
            let dt = (new Date()) - start_time;
            if (dt > rate) {
                // no timeout required
                pull();
            } else {
                window.setTimeout(pull, rate - dt);
            }
        });
    if (update_count % raw_files_update_frequency == 1) {
        hostget("files")
            .then(function (response) {
                return response.json();
            }).then(function (js) {
                update_raw_download_buttons(js);
            });
    }
}

function update_raw_download_buttons(files)
{
    let root = document.getElementById('download_raw_div');
    while (root.children.length > 0) {
        root.removeChild(root.children[0]);
    }
    for (let file_i in files) {
        let file = files[file_i];
        let el = document.createElement('button');
        el.onclick = on_download_raw_click;
        el.textContent = file;
        el.classList.add('download_raw');
        root.appendChild(el);
    }
}

var ontimeout = {{ refresh }} ? reload : pull;
window.setTimeout(ontimeout, rate);

function getRuleBySelector(selector) {
    for (var i = 0 ; i <  document.styleSheets[0].cssRules.length ; ++i) {
        var rule = document.styleSheets[0].cssRules[i];
        if (rule.selectorText === selector) {
            return rule;
        }
    }
}

/* Toggle Diff/Last column (diff is a future plan) */

var diff_rule = getRuleBySelector(".diff");
document.getElementById("toggle_diff").onclick = function () {
    toggle_display_of_element(diff_rule)
};

/* Flow Updates */

var daily_flow_canvas = document.getElementById('daily_flow_canvas');

function resize_canvas_to_window() {
    daily_flow_canvas.width = Math.min(1440, window.innerWidth);
    daily_flow_canvas.height = 100; // should I have to do this?
}

window.onresize = function (e) {
    resize_canvas_to_window();
    redraw_averages_graph();
};

function parse_json_list_with_nans(s)
{
    return JSON.parse(s.replace(/NaN/g, 'null')).map(x => x == null ? NaN : x);
}

function update_averages(ts, data)
{
    if (averages_data === undefined) {
        return;
    }
    if (ts === undefined) {
        ts = local_now_timestamp();
    }

    let last_minute;
    let latest = {}
    let graph_count = 0;
    let latest_contents_count = 0;

    for (let index in data) {
        let key = data[index][0];
        let value = data[index][1];
        if (key === 'FlowDaily') {
            update_daily_flow(ts, value);
        }
        if (key === 'PowerDaily') {
            // nothing with it
        }
        if (key == 'LastMinute') {
            last_minute = parseInt(value);
        }
        if (key == 'PowerLatest') {
            latest['power'] = parse_json_list_with_nans(value);
            latest_contents_count = latest['power'].length;
            graph_count += 1;
        }
        if (key == 'FlowLatest') {
            latest['flow'] = parse_json_list_with_nans(value);
            latest_contents_count = latest['flow'].length;
            graph_count += 1;
        }
    }
    if (last_minute !== undefined && graph_count > 0)
    {
        update_daily_averages_graph(latest, last_minute);
    }
}

var last_flow = 0.0;

function update_daily_flow(ts, flow_str)
{
    let flow = parseFloat(flow_str);
    if (flow === undefined) {
        return;
    }
    if (last_flow > flow) {
        // due to how the last minute average is taken this can actually go back.
        // instead of a more complex logic at the server we simply ignore these
        // at the client. Once the minute is passed the value is correct,
        // so the effect is small
        return;
    }
    last_flow = flow;
    let el = document.getElementById('total_daily_flow_span');
    el.textContent = display_cleanup(flow);
}

var power = undefined;
var power_min = 0;
var power_max = 650;
var flow = undefined;
const flow_max = 70;
const flow_min = 0;

function init_daily_array(arr)
{
    let ret = [];
    for (let i = 0 ; i < 24 * 60 ; ++i) {
        ret[i] = NaN;
    }
    return ret;
}

function copy_array(dest, src, dest_last)
{
    for (let f_i = dest_last, i = src.length - 1 ; i >= 0; --i, --f_i) {
        dest[f_i] = src[i];
    }
}

// hack? know when mouse is over canvas, show something semi useful - line and values
var canvas_hover_x = undefined;
var canvas_last_minute = 0;

function show_hover(d)
{
    function clean_unit(attr, name, unit) {
        return (d === undefined || isNaN(d[attr])) ? '' : (name + ' <b>' +  + display_cleanup(d[attr]) + '</b> ' + unit);
    }
    function fill(id, val) {
        document.getElementById(id).innerHTML = val;
    }
    fill('flow_hover_div', clean_unit('flow', 'Flow', 'LPM'));
    fill('power_hover_div', clean_unit('power', 'Power', 'Watt'));
    fill('time_hover_div', d === undefined ? '' : d.time);
}

function pad_left(s, p, c)
{
    // TODO: horrible
    ret = s;
    while (ret.length < c) {
        ret = p + ret;
    }
    return ret;
}

function x_to_hhmm(min)
{
    let hour = parseInt(min / 60);
    min = parseInt(min % 60);
    return pad_left('' + hour, '0', 2) + ':' + pad_left('' + min, '0', 2);
}

function canvas_onmousemove(e)
{
    let flow_length = flow === undefined ? 1440 : flow.length;
    // See: https://stackoverflow.com/questions/294250/how-do-i-retrieve-an-html-elements-actual-width-and-height#294273
    canvas_hover_x = e.offsetX * (flow_length / daily_flow_canvas.clientWidth);
    redraw_averages_graph();
}

function canvas_onmouseout()
{
    canvas_hover_x = undefined;
    redraw_averages_graph();
}

daily_flow_canvas.onmouseout = canvas_onmouseout;
daily_flow_canvas.onmousemove = canvas_onmousemove;

function update_daily_averages_graph(updates, last_minute)
{
    if (flow === undefined) {
        flow = init_daily_array();
    }
    if (power === undefined) {
        power = init_daily_array();
    }
    let to_be_updated = {flow: flow, power: power};
    for (let update_key in to_be_updated) {
        let updated = to_be_updated[update_key];
        let update_arr = updates[update_key];
        copy_array(updated, update_arr, last_minute);
    }
    canvas_last_minute = last_minute;
    redraw_averages_graph();
}

function redraw_averages_graph()
{
    let last_minute = canvas_last_minute;
    let verticals = [{
                color: 'rgba(255, 0, 0, 0.5)',
                position: last_minute + 1
            }];
    if (canvas_hover_x !== undefined) {
        let intx = parseInt(canvas_hover_x);
        show_hover({power: power[intx], flow: flow[intx], time: x_to_hhmm(canvas_hover_x)});
        verticals.push({color: 'rgba(20, 20, 20, 1.0)', position: canvas_hover_x});
    } else {
        show_hover();
    }
    return render_graph(daily_flow_canvas,
        undefined,
        {
            data: {
                flow: {
                    min_val: flow_min,
                    max_val: flow_max,
                    data: flow,
                },
                power: {
                    min_val: power_min,
                    max_val: power_max,
                    data: power,
                    color: 'rgb(20, 200, 20)',
                },
            },
            verticals: verticals,
        });
}

/* Download raw files */

function on_download_raw_click(ev)
{
    var filename = ev.target.textContent;
    var url = hosturl("download/" + filename);
    // Note: no headers here. So user should be presented with a password as usual
    window.open(url, "download_" + filename);
}

/* Downloading averaged files */

var download_date_start = document.getElementById('download_date_start');
var download_date_end = document.getElementById('download_date_end');
var today = function() {
    var d = new Date();
    return (1900 + d.getYear()) + '-' + pad(d.getMonth() + 1, 2) + '-' + pad(d.getDate(), 2);
}();
download_date_start.value = download_date_end.value = today;

var download_average__start;

function download_averaged_files(e, button_enabler) {
    var checked_interval_element = Array.from(document.getElementsByClassName('download_interval')).filter(x => x.checked)[0];
    var interval = checked_interval_element.value; // no need to parse, we immediately turn it to a string, and server checks for correctness anyway
    var start = download_date_start.value;
    var end = document.getElementById('download_date_end').value;
    var longop = long_operation__create('download average');
    hostget('task/start/avg/' + interval + "/" + start + "/" + end + "/")
        .then(function (response) { return response.json(); })
        .then(function (json) {
            let status_url = json.status_url;
            if (status_url === undefined) {
                show_error('server error, call Alon - average download');
            } else {
              download_average__start = new Date();
              average_status_tracker(status_url, longop, button_enabler);
            }
        })
        // TODO - HTTP error response handling
        //.finally()
        ;
}


function average_status_tracker(status_url, longop, button_enabler)
{
    let reset = function () { longop.finished(); button_enabler(); }
    let now = new Date();
    longop.update('downloading average (started ' + parseInt((now - download_average__start) / 1000) + ' seconds ago)');
    hostget(status_url)
        .then(function (response) { return response.json(); })
        .then(function (json) {
            if (json.result_url !== undefined) {
                average_download_result(json.result_url, button_enabler);
                reset();
            } else {
                window.setTimeout(average_status_tracker, 1000.0, status_url, longop, button_enabler);
            }
        })
        .catch(function () {
            show_error('averaging download failed');
            reset();
        })
}


function average_download_result(result_url, button_enabler)
{
    // TODO - should this happen in the same page?
    // Avoid cache by random parameter (ignored by server)
    window.open(hosturl(result_url + '?nonce=' + Math.random()), "download_averaged")
}


function disabler(element_id, callback)
{
    let el = document.getElementById(element_id);
    return function(e) {
        el.disabled = true;
        callback(e, function () {
          el.disabled = false;
        });
    }
}

document.getElementById('download_button').onclick =
    disabler('download_button', download_averaged_files);


/* Development options */
var print_time_el = document.getElementById('print_time');
var loop_time_el = document.getElementById('loop_time');

input_int_to_url(print_time_el, '/restart/print_time/');
input_int_to_url(loop_time_el, '/restart/mppt_loop_time/');

/* Vars.csv change */

var varscsv_input = document.getElementById("varscsv_input");

function varscsv_button_onclick()
{
    let text = varscsv_input.value;
    console.log('TODO varscsv');
    console.log(text);
    hostpostjson('varscsv', text)
        .then(function (response) {
            return response.json();
        }).then(function (js) {
            show_error(js['ok'] ? '' : js['error']);
        });
}

// get current file now - we are mostly the only ones changing it, so it's good
// enough. Also, it's a starting point, not a reflection of reality)
window.setTimeout(function () {
    hostget('varscsv')
        .then(response => response.json())
        .then(js => { varscsv_input.value = js; });
}, 0);

/* Executable */

function update_executable(files)
{
    console.log(files);
    hostpostfile('executable', files[0])
        .then(function (response) {
            return response.json();
        }).then(function (js) {
            show_error(js['ok'] ? '' : js['error']);
        });
}

var error_el = document.getElementById('error_div')

function show_error(text)
{
    if (text == '') {
        error_el.innerHTML = '';
    } else {
        error_el.innerHTML = '<b>error:</b>:\n<pre style="white-space: pre-wrap">' + text + '</pre>';
    }
}

/* Status indicators */

var status_indicators = {
    pump_usb: (state => update_status_indicator('status_pump_usb_div', state.devices.pump)),
    mppt_usb: (state => update_status_indicator('status_mppt_usb_div', state.devices.mppt)),
}


function update_status_indicator(elid, good)
{
    let el = document.getElementById(elid);
    // classes are probably the canonical approach here
    el.style['background-color'] = good ? 'rgba(0, 255, 0, 0.5)' : 'rgba(255, 0, 0, 0.5)';
}


function update_status_indicators(state)
{
    for (let k in status_indicators) {
        let cb = status_indicators[k];
        cb(state);
    }
}

/* Initialize Graph */
(function init() {
    if (!graph_enabled) {
        return;
    }
    // The template leaves history as a key->scalar, turn it into a key->history
    graph_history = {};
    graph_limits = {};
    for (let key in graph_initial) {
        let value_str = graph_initial[key];
        // first check we actually support this key based on the initial value
        // we only support floats right now. Enumerations (categorical data, like MODE_X)
        // are TODO
        let value = parseFloat(value_str);
        if (isNaN(value)) {
            continue;
        }
        graph_history[key] = new Array(graph_width);
        for (let i = 1 ; i < graph_width ; ++i) {
            graph_history[key][i] = 0;
        }
        graph_history[key][0] = value;
        graph_limits[key] = [0, 15];
    }

    requestAnimationFrame(graph_render);
    window.setInterval(graph_history_fade, graph_dt);
})();

(function init2() {
    // initial update of graph from server rendered html
    resize_canvas_to_window();
    update_daily_averages_graph(
        {
            flow: averages_data['per_minute']['flow'],
            power: averages_data['per_minute']['power'],
        },
        averages_data['per_minute']['flow'].length - 1);
})();


</script>
</body>
</html>
